=== debian/changelog ===
prboom-plus (2:2.5.1.7um+git89-1) unstable; urgency=medium

  * New upstream version 2.5.1.7um+git89
  * Remove config-debian.patch, all changes have been addressed
    upstream.
  * Replace all Suggests with ffmpeg, upstream has switched to an
    ffmpeg-based viddump approach.
  * Adapt packaging to upstream install rule.
  * Add usr/bin/prboom-plus to debian/not-installed, we install
    usr/bin/glboom-plus instead of prboom-plus.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 26 Jun 2020 09:37:17 +0200

prboom-plus (2:2.5.1.7um+git82-1) unstable; urgency=medium

  * New upstream version 2.5.1.7um+git82 from commit fa28d882.
    + Fix heap buffer overflows in UDP code (CVE-2019-20797),
      Closes: #961031.
    + Fix compilation on big-endian architectures,
      Closes: #961336.
  * Refresh config-debian.patch, the game speed changing keys
    have been unbound upstream.

 -- Fabian Greffrath <fabian@debian.org>  Sat, 06 Jun 2020 15:09:36 +0200

prboom-plus (2:2.5.1.7um+git72-1) unstable; urgency=medium

  * Switch code base to the PrBoom+/UMAPINFO fork.
  * Adapt debian/watch file accordingly.
  * New upstream version 2.5.1.7um+git72 from commit e714a5bc.
  * Adapt debian/copyright accordingly.
  * Remove debian/gbp.conf.
  * Change default music backend back to SDL. OPL2 emulation is CPU
    expensive and MIDI rendering works with a default soundfont in SDL
    nowadays.
  * Add cmake to Build-Depends, upstream has changed the build
    system.
  * Adapt debian/rules and install rules to the changed build system.
  * Run "wrap-and-sort -asb".
  * No need to repack sources anymore, upstream has replaced or
    entirely removed all dubious or non-free data lumps.
  * Bump debhelper-compat to 13.
  * Bump Standards-Version to 4.5.0.
  * Rules-Requires-Root: no.
  * Strip "as-needed" LDFLAGS from debian/rules.
  * Remove obsolete Breaks and Replaces relations.
  * Install glboom-plus as prboom-plus.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 22 May 2020 16:33:38 +0200

prboom-plus (2:2.5.1.5+svn4540+dfsg1-2) unstable; urgency=medium

  * Remove myself from Uploaders.

 -- Jonathan Dowland <jmtd@debian.org>  Mon, 11 May 2020 10:14:12 +0100
