=== debian/control ===
Source: prboom-plus
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Fabian Greffrath <fabian@debian.org>
Build-Depends:
 bash-completion,
 cmake,
 debhelper-compat (= 13),
 libdumb1-dev,
 libfluidsynth-dev,
 libgl1-mesa-dev | libgl-dev,
 libglu1-mesa-dev | libglu-dev,
 libmad0-dev,
 libpcre3-dev,
 libpng-dev,
 libportmidi-dev [linux-any],
 libsdl2-dev (>= 2.0.0),
 libsdl2-image-dev,
 libsdl2-mixer-dev,
 libsdl2-net-dev,
 libvorbis-dev
Standards-Version: 4.5.0
Homepage: https://github.com/coelckers/prboom-plus
Vcs-Git: https://salsa.debian.org/games-team/prboom-plus.git
Vcs-Browser: https://salsa.debian.org/games-team/prboom-plus
Rules-Requires-Root: no

Package: prboom-plus
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 freedoom | game-data-packager
Suggests:
 ffmpeg
Provides:
 boom-engine,
 doom-engine
Description: enhanced clone of the classic first-person shooter Doom
 PrBoom+ is an enhanced source port of the classic 3D first-person
 shooter game Doom, first released by id Software in 1993. It uses
 the Simple Direct Media layer (SDL) library and features an optional
 OpenGL renderer. It is based on PrBoom, MBF and LxDoom, which in turn
 are based on TeamTNT's Boom, a freely available port of Doom for DOS.
 .
 In addition to PrBoom's features, PrBoom+ offers uncapped framerate,
 variable gamespeed, re-record, walkcam, chasecam, full mouselook,
 FOV, and other features without loss of compatibility with the
 original Doom.
 .
 PrBoom+ requires game data to run. Free game data is available in the
 freedoom package. Commercial game data can be packaged using
 game-data-packager. PrBoom+ supports all flavors of Doom, including
 The Ultimate Doom, Doom 2 and Final Doom as well as Chex(R) Quest, HACX,
 FreeDoom and FreeDM.

Package: prboom-plus-game-server
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: enhanced clone of the classic first-person shooter Doom (server)
 PrBoom+ is an enhanced source port of the classic 3D first-person
 shooter game Doom, first released by id Software in 1993. It uses
 the Simple Direct Media layer (SDL) library and features an optional
 OpenGL renderer. It is based on PrBoom, MBF and LxDoom, which in turn
 are based on TeamTNT's Boom, a freely available port of Doom for DOS.
 .
 In addition to PrBoom's features, PrBoom+ offers uncapped framerate,
 variable gamespeed, re-record, walkcam, chasecam, full mouselook,
 FOV, and other features without loss of compatibility with the
 original Doom.
 .
 This package contains the server for network games of PrBoom+.
