=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ \
		--sourcedirectory=prboom2 \
		--with bash_completion

override_dh_install:
	dh_install
	# install glboom-plus as prboom-plus
	mv debian/prboom-plus/usr/games/glboom-plus \
	   debian/prboom-plus/usr/games/prboom-plus
