## prboom-plus 2.6um

=== prboom2/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,19 @@
 cmake_minimum_required(VERSION 3.0)
 
-project("PrBoom-Plus" VERSION 2.5.1.7)
+project("PrBoom-Plus"
+    VERSION 2.6
+    HOMEPAGE_URL "https://github.com/coelckers/prboom-plus")
+
+# Set a default build type if none was specified
+set(default_build_type "RelWithDebInfo")
+if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+  message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
+  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
+      STRING "Choose the type of build." FORCE)
+  # Set the possible values of build type for cmake-gui
+  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
+    "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
+endif()
 
 set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
@@ -8,6 +21,8 @@
 
 include(TestBigEndian)
 TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
+
+include(GNUInstallDirs)
 
 # Automated dependencies discovery, mostly needed for MSVC
 target_architecture(TARGET_ARCH)
@@ -20,8 +35,10 @@
 
 set(PACKAGE_NAME "${PROJECT_NAME}")
 set(PACKAGE_TARNAME "prboom-plus")
-set(PACKAGE_VERSION "${PROJECT_VERSION}")
+set(PACKAGE_VERSION "${PROJECT_VERSION}um")
+set(PACKAGE_HOMEPAGE "${PROJECT_HOMEPAGE_URL}")
 set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
+set(CMAKE_INSTALL_DOCDIR "${CMAKE_INSTALL_DATAROOTDIR}/doc/${PACKAGE_TARNAME}")
 
 include(CheckSymbolExists)
 
@@ -46,7 +63,8 @@
     endif()
 endif()
 check_symbol_exists(usleep "unistd.h" HAVE_USLEEP)
-check_symbol_exists(sys_siglist "signal.h" HAVE_DECL_SYS_SIGLIST)
+check_symbol_exists(strsignal "string.h" HAVE_STRSIGNAL)
+check_symbol_exists(mkstemp "stdlib.h" HAVE_MKSTEMP)
 
 include(CheckIncludeFile)
 
@@ -59,7 +77,7 @@
     find_package(OpenGL)
 endif()
 
-find_package(SDL2 REQUIRED)
+find_package(SDL2 2.0.7 REQUIRED)
 
 option(WITH_IMAGE "Use SDL2_image if available" ON)
 if(WITH_IMAGE)
@@ -178,10 +196,30 @@
     )
 endif()
 
+# Support cross compiling
+option(FORCE_CROSSCOMPILE "Enable cross-compilation" OFF)
+if(FORCE_CROSSCOMPILE)
+    set(CMAKE_CROSSCOMPILING ON)
+endif()
+
+if(CMAKE_CROSSCOMPILING)
+    set(IMPORT_EXECUTABLES "IMPORTFILE-NOTFOUND" CACHE FILEPATH "Export file from native build")
+    include(${IMPORT_EXECUTABLES})
+else()
+    if(NOT CROSS_EXPORTS)
+        set(CROSS_EXPORTS "")
+    endif()
+endif()
+
 set(PRBOOM_OUTPUT_PATH ${CMAKE_BINARY_DIR})
 
 set(WAD_DATA prboom-plus.wad)
 set(WAD_DATA_PATH "${PRBOOM_OUTPUT_PATH}/${WAD_DATA}")
 
 add_subdirectory(data)
+add_subdirectory(doc)
 add_subdirectory(src)
+
+if(NOT CMAKE_CROSSCOMPILING)
+    export(TARGETS ${CROSS_EXPORTS} FILE "${CMAKE_BINARY_DIR}/ImportExecutables.cmake")
+endif()
