=== prboom2/src/CMakeLists.txt ===
--- 
+++ 
@@ -261,6 +261,34 @@
 )
 
 function(AddGameExecutable TARGET SOURCES)
+    if(OPENGL_FOUND AND OPENGL_GLU_FOUND)
+        set(SOURCES
+            ${SOURCES}
+            gl_clipper.c
+            gl_detail.c
+            gl_drawinfo.c
+            gl_fbo.c
+            gl_gamma.c
+            gl_hires.c
+            gl_hqresize.c
+            gl_intern.h
+            gl_light.c
+            gl_main.c
+            gl_map.c
+            gl_missingtexture.c
+            gl_opengl.c
+            gl_opengl.h
+            gl_preprocess.c
+            gl_shader.c
+            gl_shadow.c
+            gl_sky.c
+            gl_struct.h
+            gl_texture.c
+            gl_vertex.c
+            gl_wipe.c
+        )
+    endif()
+
     if(WIN32)
         add_definitions("-DUSE_WIN32_PCSOUND_DRIVER -DUSE_WINDOWS_LAUNCHER")
         set(SOURCES
@@ -341,54 +369,25 @@
         )
     endif()
 
-    install(TARGETS ${TARGET} COMPONENT "Game executable")
+    install(TARGETS ${TARGET} COMPONENT "Game executable" RUNTIME DESTINATION "${CMAKE_INSTALL_PREFIX}/bin")
+
+    if(OPENGL_FOUND AND OPENGL_GLU_FOUND)
+        target_compile_definitions(${TARGET} PRIVATE
+            GL_DOOM
+            USE_SHADERS
+            USE_FBO_TECHNIQUE
+            USE_GLU_IMAGESCALE
+            USE_GLU_MIPMAP
+            USE_GLU_TESS
+        )
+        target_link_libraries(${TARGET} PRIVATE
+            ${OPENGL_gl_LIBRARY}
+            ${OPENGL_glu_LIBRARY}
+        )
+    endif()
 endfunction()
 
 AddGameExecutable(prboom-plus "${PRBOOM_PLUS_SOURCES}")
-
-# GLBoom main executable
-
-if(OPENGL_FOUND AND OPENGL_GLU_FOUND)
-    set(GLBOOM_PLUS_SOURCES
-        ${PRBOOM_PLUS_SOURCES}
-        gl_clipper.c
-        gl_detail.c
-        gl_drawinfo.c
-        gl_fbo.c
-        gl_gamma.c
-        gl_hires.c
-        gl_hqresize.c
-        gl_intern.h
-        gl_light.c
-        gl_main.c
-        gl_map.c
-        gl_missingtexture.c
-        gl_opengl.c
-        gl_opengl.h
-        gl_preprocess.c
-        gl_shader.c
-        gl_shadow.c
-        gl_sky.c
-        gl_struct.h
-        gl_texture.c
-        gl_vertex.c
-        gl_wipe.c
-    )
-
-    AddGameExecutable(glboom-plus "${GLBOOM_PLUS_SOURCES}")
-    target_compile_definitions(glboom-plus PRIVATE
-        GL_DOOM
-        USE_SHADERS
-        USE_FBO_TECHNIQUE
-        USE_GLU_IMAGESCALE
-        USE_GLU_MIPMAP
-        USE_GLU_TESS
-    )
-    target_link_libraries(glboom-plus PRIVATE
-        ${OPENGL_gl_LIBRARY}
-        ${OPENGL_glu_LIBRARY}
-    )
-endif()
 
 
 # PrBoom-Plus server executable
@@ -428,7 +427,7 @@
         RUNTIME_OUTPUT_DIRECTORY ${PRBOOM_OUTPUT_PATH}
     )
     ApplySDL2NetOptions(prboom-plus-game-server)
-    install(TARGETS prboom-plus-game-server COMPONENT "Game server executable")
+    install(TARGETS prboom-plus-game-server COMPONENT "Game server executable" RUNTIME DESTINATION "${CMAKE_INSTALL_PREFIX}/bin")
 endif()
 
 
@@ -493,11 +492,7 @@
     )
     add_dependencies(prboom-plus-launcher prboom-plus)
 
-    if(OPENGL_FOUND AND OPENGL_GLU_FOUND)
-        set(BUNDLE_GAME_EXECUTABLE glboom-plus)
-    else()
-        set(BUNDLE_GAME_EXECUTABLE prboom-plus)
-    endif()
+    set(BUNDLE_GAME_EXECUTABLE prboom-plus)
 
     add_custom_command(TARGET prboom-plus-launcher POST_BUILD
         COMMAND ${CMAKE_COMMAND} -E copy_if_different $<TARGET_FILE:${BUNDLE_GAME_EXECUTABLE}> $<TARGET_FILE_DIR:prboom-plus-launcher>/PrBoom-Plus
@@ -507,6 +502,3 @@
     if(BUILD_SERVER AND SDL2_NET_FOUND)
         add_dependencies(prboom-plus-launcher prboom-plus-game-server)
         add_custom_command(TARGET prboom-plus-launcher POST_BUILD
-            COMMAND ${CMAKE_COMMAND} -E copy_if_different $<TARGET_FILE:prboom-plus-game-server> $<TARGET_FILE_DIR:prboom-plus-launcher>
-        )
-    endif()
