=== debian/changelog ===
prboom-plus (2:2.6um-1) unstable; urgency=medium

  * New upstream version 2.6um
  * Do not install glboom-plus anymore, it has been superseded by
    plain prboom-plus.
  * Install prboom2/NEWS as upstream changelog.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 09 Feb 2021 13:56:30 +0100

prboom-plus (2:2.5.1.7um+git127-1) unstable; urgency=medium

  * New upstream version 2.5.1.7um+git127
  * Adapt documentation install paths to upstream changes.

 -- Fabian Greffrath <fabian@debian.org>  Fri, 01 Jan 2021 17:22:15 +0100

prboom-plus (2:2.5.1.7um+git102-1) unstable; urgency=medium

  * New upstream version 2.5.1.7um+git102
  * Adapt documentation install paths to upstream changes.

 -- Fabian Greffrath <fabian@debian.org>  Tue, 03 Nov 2020 21:14:08 +0100
