=== debian/control ===
--- 
+++ 
@@ -54,8 +54,8 @@
  PrBoom+ requires game data to run. Free game data is available in the
  freedoom package. Commercial game data can be packaged using
  game-data-packager. PrBoom+ supports all flavors of Doom, including
- The Ultimate Doom, Doom 2 and Final Doom as well as Chex(R) Quest, HACX,
- FreeDoom and FreeDM.
+ The Ultimate Doom, Doom 2 and Final Doom as well as Chex(R) Quest, HacX,
+ Freedoom: Phase 1 and Phase 2 and FreeDM.
 
 Package: prboom-plus-game-server
 Architecture: any
