=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ \
		--sourcedirectory=prboom2 \
		--with bash_completion

override_dh_installchangelogs:
	dh_installchangelogs -- prboom2/NEWS
