=== debian/watch ===
version=4
https://github.com/coelckers/@PACKAGE@/releases \
/coelckers/@PACKAGE@/archive/v@ANY_VERSION@@ARCHIVE_EXT@
